/// <reference types="react" />
export interface ILoc {
    x: number;
    y: number;
}
export declare const getFileName: () => string;
export declare const rgb2hex: (r: number, g: number, b: number) => string;
export declare const getLocInfo: (firstLoc: ILoc, lastLoc: ILoc) => number[];
/** 获取长宽 */
export declare const getWidthAndHeight: (image: HTMLImageElement, width?: number, height?: number) => [number, number];
/** 获取鼠标坐标, 相对 canvas */
export declare const windowToCanvas: (ele: HTMLElement, x: number, y: number) => {
    x: number;
    y: number;
};
export declare const realWindowToCanvas: (ele: HTMLElement, x: number, y: number) => {
    x: number;
    y: number;
};
/** imageData => 渲染, putImageData性能比较差, 头疼(暂时不需要, 但这个处理canvas的还是保留了) */
export declare const drawImgCanvas: (puzzleEle: HTMLCanvasElement, box: HTMLCanvasElement, startRow: number, startCol: number, w: number, h: number, size: number[]) => void;
export declare const handleMoveEffect: ({ firstLoc, lastLoc, puzzleEle, ratioRef, parentEle, context, image }: {
    firstLoc: ILoc;
    lastLoc: ILoc;
    puzzleEle: HTMLCanvasElement;
    ratioRef: import("react").RefObject<any>;
    parentEle: HTMLDivElement;
    context: any;
    image: HTMLImageElement;
}) => () => void;
export declare const getPointByLoc: (firstLoc: ILoc, curLoc: ILoc) => {
    x: number;
    y: number;
}[];
export declare const setToolsLocEffect: (puzzleEle: HTMLCanvasElement, toolsEle: HTMLDivElement, toolsLoc: any, parentH: number) => void;
export declare const useCombinedRefs: (...refs: any) => import("react").MutableRefObject<any>;
export declare const drawHorizontalLine: (context: CanvasRenderingContext2D) => void;
export declare const drawVerticalLine: (context: CanvasRenderingContext2D) => void;
export declare const drawLocCanvas: ({ image, box, ele, loc, ratioRef, event, size }: {
    image: HTMLImageElement;
    box: HTMLDivElement;
    ele: HTMLCanvasElement;
    loc: ILoc;
    ratioRef: import("react").RefObject<any>;
    event: MouseEvent | import("react").MouseEvent<Element, MouseEvent>;
    size?: number;
}) => void;
export declare const drawSvg: (firstLoc: ILoc, lastLoc: ILoc, svgEle: SVGElement) => number[];
export declare const drawSvgOnCanvas: (type: "rect" | "circle", firstLoc: ILoc, lastLoc: ILoc, context: CanvasRenderingContext2D, ratio: number, info: {
    size: number;
    color: string;
}) => () => void;
export declare const drawLine: (lastLoc: ILoc, curLoc: ILoc, context: CanvasRenderingContext2D, ratio: number, info: {
    size: number;
    color: string;
}) => void;
export declare const drawMosaic: (context: CanvasRenderingContext2D, x: number, y: number, size: number, trackSize?: number) => void;
